SHEBANG
# Copyright (C)2013..2014 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2014/08/13 19:23:30 babolo Exp $

JNTROSTUP(dhcpd-isc,,dnl
,dnl
# jailup ${kind} dir jailname jailaddr if
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
# ${inclass} from base system used
# Default genclass is "${inclass}".
dnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
juid="100136"
jgid="100136"
if="${4}"

main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"
if  [ -n "${CONFSHIFT}" ]; then
    conf_dir="${conf_dir}/${CONFSHIFT}"
fi

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_genlist} libexec/ ${MTREE} | ${up_libexe} "${main_dir}/libexec/"
${up_genlist} libexec/ ${MTREE} | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"
ETCOPY()
${up_ponf} "${conf_dir}/dhcpd.conf" "${TEMPLATE}"

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:
	daemon:*:1:dhcpd
	nogroup:*:65533:
	nobody:*:65534:
	dhcpd:*:${jgid}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	dhcpd:*:${juid}:${jgid}::0:0:${inclass}:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
EOF

${touch} "${main_dir}/var/db/dhcpd/dhcpd.leases"
${up_mtree} "${main_dir}" ${MTREE}
${chown} ${juid} "${main_dir}/var/run"

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	dhcpd	dhcpd	${if}
EOF

${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev		devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc		nullfs	ro,noexec	0 0
EOF

${up_adc} "${STARTUPDIR}/devfs" <<- EOF
	${jdir}	bpf	${inclass}${suffix}
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

echo "add ${PREFIX}/libexec/jailup/${inclass}${suffix}/template-rules to ${STARTUPDIR}/rules"
